<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "payment_type".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "PaymentType".
 *
 * Columns in table "payment_type" available as properties of the model,
 * followed by relations of table "payment_type" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property string $class_name
 *
 * @property ProviderPaymentType[] $providerPaymentTypes
 */
abstract class BasePaymentType extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'payment_type';
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name, class_name', 'required'),
            array('name', 'length', 'max' => 50),
            array('class_name', 'length', 'max' => 10),
            array('id, name, class_name', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'providerPaymentTypes' => array(self::HAS_MANY, 'ProviderPaymentType', 'payment_type_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'class_name' => Yii::t('app', 'Class Name'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('class_name', $this->class_name, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'PaymentType|PaymentTypes', $n);
    }

}
